/***************************************************************************
 *            dw.c
 *
 *  Sat Nov 20 19:12:15 2004
 *  Copyright  2004  Marcin K. Krzywonos
 *  mkk@gnutu.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gnome.h>
#include <var.h>
#include <dirent.h>

#include "dw.h"


int dw_load_entry (type_date date)
{
	GtkWidget     *dw_date_date_edit  = (gpointer) lookup_widget (GTK_WIDGET (dw_widget), "dw_date_date_edit");
	GtkWidget     *dw_notes_text_view = (gpointer) lookup_widget (GTK_WIDGET (dw_widget), "dw_notes_text_view");
	GtkTextBuffer *text_buffer        = gtk_text_view_get_buffer (GTK_TEXT_VIEW (dw_notes_text_view));
	
	gtk_text_buffer_set_text (text_buffer, "", strlen (""));
	
	gchar tmp [300];
	gchar txt [8192];
	sprintf (tmp, "%s/.gnutu/diary/%d-%d-%d.gtu", g_get_home_dir(), date.day, date.month, date.year);
	
	FILE *file = fopen (tmp, "r");
	
	// Jezeli plik zostal otwarty to wczytujemy go
	if (file != NULL) {
		// Wczytujemy tekst
		while (fgets (txt, 8192, file))
			gtk_text_buffer_insert_at_cursor (text_buffer, txt, strlen (txt));
		
		fclose (file);
	}
	
	dw_entry_date = date;
	dw_date_label_set (dw_entry_date);
	
	gnome_date_edit_set_time (GNOME_DATE_EDIT (dw_date_date_edit), typedate_to_timet (date));
	
	return 0;
}


int dw_save_entry (type_date date)
{
	// Wczytanie zawartosci widgetu edytora do zmiennej txt
	gchar *txt;
	
	GtkWidget     *dw_notes_text_view = (gpointer) lookup_widget (GTK_WIDGET (dw_widget), "dw_notes_text_view");
	GtkTextBuffer *text_buffer        = gtk_text_view_get_buffer (GTK_TEXT_VIEW (dw_notes_text_view));
	GtkTextIter    start, end;
	
	gtk_text_buffer_get_bounds (text_buffer, &start, &end);
	txt = gtk_text_buffer_get_text (text_buffer, &start, &end, TRUE);
	
	// Proba zapisu wpisu dziennika
	gchar  tmp [300];
	sprintf (tmp, "%s/.gnutu/diary/%d-%d-%d.gtu", g_get_home_dir(), date.day, date.month, date.year);
	
	FILE *file = fopen (tmp, "w");
	
	// W przypadku niepowodzenia zostanie podjeta proba utworzenia
	// katalogu dziennika i ponownego otwarcia pliku
	if (file == NULL) {
		system ("mkdir ~/.gnutu/diary");
		file = fopen (tmp, "w");
	}
	
	if (file != NULL) {
		fputs (txt, file);
		fclose (file);
	} else {
		// Jezeli nie udalo sie otworzyc pliku wyswietlamy komunikat bledu
		g_print (_("BLAD: Nie mozna zapisac pliku dziennika !\n"));
		return 1;
	}
	
	// Jezeli wpis jest pusty to zostaje on usuniety
	if (strlen (txt) == 0)
		remove (tmp);
	
	return 0;
}


int dw_date_label_set (type_date date)
{
	GtkWidget *dw_date_label = (gpointer) lookup_widget (GTK_WIDGET (dw_widget), "dw_date_label");
	
	gchar tmp[100];
	sprintf (tmp, _("Data: <b>%d-%d-%d</b>"), date.day, date.month, date.year);
	
	gtk_label_set_label (GTK_LABEL (dw_date_label), tmp);
	
	return 0;
}
