/***************************************************************************
 *            sw.c
 *
 *  Sun Dec  5 15:33:40 2004
 *  Copyright  2004  Marcin K. Krzywonos
 *  mkk@gnutu.org
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 

#include "sw.h"
#include "var.h"


/*
 * Funckja wczytuje ustawienia domyslne
 */
int sw_default_settings ()
{    
	gtudb_settings_set_value ("insert_subjects", "TRUE");
	gtudb_settings_set_value ("show_new_tests", "TRUE");
	gtudb_settings_set_value ("show_days_counter", "TRUE");
	gtudb_settings_set_value ("show_new_tests_days", "14");
	gtudb_settings_set_value ("show_info_about_day", "TRUE");
	gtudb_settings_set_value ("school_year_begin", "1-9-2004");
	gtudb_settings_set_value ("school_year_end", "25-6-2005");
	gtudb_settings_set_value ("vacation_end", "31-8-2005");
	
	gtudb_settings_write ();
}


/*
 * Funkcja zapisuje glowne ustawienia
 */
int sw_save_general ()
{
	sw_toogle_btn_get_settings ("insert_subjects");
	
	return 0;
}


/*
 * Funkcja zapisuje ustawienia lewego paska informacyjnego
 */
int sw_save_left_bar ()
{
	sw_toogle_btn_get_settings ("show_info_about_day");
	sw_toogle_btn_get_settings ("show_new_tests");
	sw_toogle_btn_get_settings ("show_days_counter");
	
	sw_spin_btn_get_settings   ("show_new_tests_days");
	
	sw_gde_btn_get_settings    ("school_year_begin");
	sw_gde_btn_get_settings    ("school_year_end");
	sw_gde_btn_get_settings    ("vacation_end");
	
	return 0;
}


/*
 * Funkcja odczytuje glowne ustawienia
 */
int sw_read_general ()
{
	sw_toogle_btn_set_settings ("insert_subjects");
	
	return 0;
}


/*
 * Funkcja odczytuje ustawienia lewego paska informacyjnego
 */
int sw_read_left_bar ()
{
	sw_toogle_btn_set_settings ("show_info_about_day");
	sw_toogle_btn_set_settings ("show_new_tests");
	sw_toogle_btn_set_settings ("show_days_counter");
	
	sw_spin_btn_set_settings   ("show_new_tests_days");
	
	sw_gde_btn_set_settings    ("school_year_begin");
	sw_gde_btn_set_settings    ("school_year_end");
	sw_gde_btn_set_settings    ("vacation_end");
	
	return 0;
}


/*
 * Funkcja pobiera stan widgetu gtk_toogle_btn i zapisuje informacje do bazy
 */
int sw_toogle_btn_get_settings (gchar *name)
{
	gchar name2 [100];
	sprintf (name2, "sw_%s", name);
	
	GtkWidget *tmp = (gpointer) lookup_widget (GTK_WIDGET (sw_widget), name2);
	
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON (tmp)) == TRUE)
		gtudb_settings_set_value (name, "TRUE");
	else
		gtudb_settings_set_value (name, "FALSE");
	
	return 0;
}


/*
 * Funkcja pobiera stan widgetu gnome_date_edit i zapisuje informacje do bazy
 */
int sw_gde_btn_get_settings (gchar *name)
{
	gchar name2 [100];
	sprintf (name2, "sw_%s", name);
	
	GtkWidget *tmp  = (gpointer) lookup_widget (GTK_WIDGET (sw_widget), name2);
	type_date  date = timet_to_typedate (gnome_date_edit_get_time (GNOME_DATE_EDIT (tmp)));
	gchar      rtn [15];
	
	sprintf (rtn, "%d-%d-%d\n", date.day, date.month, date.year);
	gtudb_settings_set_value (name, rtn);
	
	return 0;
}


/*
 * Funkcja pobiera stan widgetu gtk_spin_button i zapisuje informacje do bazy
 */
int sw_spin_btn_get_settings (gchar *name)
{
	gchar name2 [100];
	sprintf (name2, "sw_%s", name);
	
	GtkWidget *tmp  = (gpointer) lookup_widget (GTK_WIDGET (sw_widget), name2);
	gchar      rtn [20];
	
	sprintf (rtn, "%d", gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON (tmp)));
	gtudb_settings_set_value (name, rtn);
	
	return 0;
}


/*
 * Funkcja wczytuje do widgetu gtk_toggle_button informacje do bazy
 */
int sw_toogle_btn_set_settings (gchar *name)
{
	gchar name2 [100];
	sprintf (name2, "sw_%s", name);
	
	GtkWidget *tmp = (gpointer) lookup_widget (GTK_WIDGET (sw_widget), name2);
	
	if (strcmp ((gchar *) gtudb_settings_get_value (name), "TRUE") == 0)
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmp), TRUE);
	else
		gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (tmp), FALSE);
	
	return 0;
}


/*
 * Funkcja wczytuje do widgetu gnome_date_edit informacje do bazy
 */
int sw_gde_btn_set_settings (gchar *name)
{
	gchar name2 [100];
	sprintf (name2, "sw_%s", name);
	
	GtkWidget *tmp = (gpointer) lookup_widget (GTK_WIDGET (sw_widget), name2);
	gnome_date_edit_set_time (GNOME_DATE_EDIT (tmp), typedate_to_timet (gdate_to_type_date (text_to_gdate ((gchar *) gtudb_settings_get_value (name)))));
		
	return 0;
}


/*
 * Funkcja wczytuje do widgetu gtk_spin_button informacje do bazy
 */
int sw_spin_btn_set_settings (gchar *name)
{
	gchar name2 [100];
	sprintf (name2, "sw_%s", name);
	
	GtkWidget *tmp  = (gpointer) lookup_widget (GTK_WIDGET (sw_widget), name2);
	gtk_spin_button_set_value (GTK_SPIN_BUTTON (tmp), atoi ((gchar *) gtudb_settings_get_value (name)));
	
	return 0;
}
